#ifndef UpperTesterMapemSpatem_LAYER_H
#define UpperTesterMapemSpatem_LAYER_H

#include "TLayer.hh"
#include "UpperTesterMapemSpatemCodec.hh"

namespace LibItsMapemSpatem__TestSystem {
  class UpperTesterPort;
}

namespace LibItsMapemSpatem__TypesAndValues {
  class UtMapemSpatemInitialize;
  class UtMapemSpatemChangePosition;
  class UtMapemSpatemTrigger;
}

class UpperTesterMapemSpatemLayer : public TLayer<LibItsMapemSpatem__TestSystem::UpperTesterPort> {
  Params _params;
  UpperTesterMapemSpatemCodec _codec;
  
public:
  UpperTesterMapemSpatemLayer() : TLayer<LibItsMapemSpatem__TestSystem::UpperTesterPort>(), _params(), _codec() {};
  UpperTesterMapemSpatemLayer(const std::string & p_type, const std::string & param);
  virtual ~UpperTesterMapemSpatemLayer() {};

  void sendMsg(const LibItsMapemSpatem__TypesAndValues::UtMapemSpatemInitialize& send_par, Params& params);
  void sendMsg(const LibItsMapemSpatem__TypesAndValues::UtMapemSpatemTrigger& send_par, Params& params);
  
  virtual void sendData(OCTETSTRING& data, Params& params);
  virtual void receiveData(OCTETSTRING& data, Params& info);
};

#endif
